
public interface TypeConstants
{
   static final int RELIX_VOID  =       -1;
 //  static final int BOOLEAN = -2; //Yi Zheng Oct 5, 2002
   static final int BOOLEAN   =  0;
   static final int SHORT  =  1;
   static final int INTEGER   =  2;
   static final int LONG   =  3;
   static final int FLOAT  =  4;
   static final int DOUBLE =  5;
   static final int NUMERIC =  6;
   static final int STRING =  7;
   static final int TEXT   =  8;
   static final int STMT   =  9;
   static final int EXPR   =  10;
//   static final int IDLIST =  11;
//   static final int COMP   =  12;
// Yi Zheng May 15, 2002, to be consistent with Constants
   static final int COMP   =  11;
   static final int IDLIST =  12;

   static final int DC          =       13;
   static final int DK          =       14;
  

//PATCHANGE: from 0,1,2 to..
   static final int RELATION  =  15;
   static final int VIEW   =  16;
   static final int COMPUTATION  =  17;
   
   static final int ATTRIBUTE  = 18;
 static final int UNIVERSAL  = 25;





   //These are used by the environmaents of computations
   static final int PARAMETER  = 0;
   static final int LOCAL      = 1;
   static final int STATE      = 2;
   static final int REL        = 3;
   static final int DOM        = 4;
   static final int NR         = 5;

   // char length on screen for various types
   // 1. long's maximum length is 20, use 12 to save screen space
   // 2. for string, by default, only the first 20 chars printed
  static final int BOOL_LEN   = 6;
   static final int SHORT_LEN  = 6;
   static final int INT_LEN    = 11;
   static final int LONG_LEN   = 20;
   static final int FLOAT_LEN  = 13;
   static final int DOUBLE_LEN = 23;
   static final int NUMERIC_LEN = 8000;
   static final int STRING_LEN = 20;

   // the result of comparing two tuples
   static final int GT         =   2;
   static final int EQDK       =   1;   // if equal but with dk
   static final int EQ         =   0;
   static final int LT         =   -2;

   static final int ERROR      = -1;
   static final int TRUE       = 1;
   static final int FALSE      = 0;

   static final String STRING_DK = "\u0000dk";
   static final String STRING_DC = "\u0000dc";

   static final byte BOOL_DK     = -2;
   static final byte BOOL_DC     = -1;
   static final byte BOOL_FALSE  = 0;
   static final byte BOOL_TRUE   = 1;

   static final short SHORT_DK   = Short.MIN_VALUE;
   static final short SHORT_DC   = (short) (Short.MIN_VALUE + 1);

   static final int INT_DK       = Integer.MIN_VALUE;
   static final int INT_DC       = Integer.MIN_VALUE + 1;

   static final long LONG_DK     = Long.MIN_VALUE;
   static final long LONG_DC     = Long.MIN_VALUE + 1;

//   static final float FLOAT_DK   = Float.NEGATIVE_INFINITY; //bug fix by Yi Zheng Sept 28, 2002
   static final float FLOAT_DK   = Float.MAX_VALUE;
   static final float FLOAT_DC   = - Float.MAX_VALUE;

//   static final double DOUBLE_DK = Double.NEGATIVE_INFINITY; //bug fix by Yi Zheng Sept 28, 2002
   static final double DOUBLE_DK = Double.MAX_VALUE;
   static final double DOUBLE_DC = - Double.MAX_VALUE;

 //  static final double NUMERIC_DK = Double.NEGATIVE_INFINITY;
 //  static final double NUMERIC_DC = - Double.MAX_VALUE;
   static final number NUMERIC_DK = number.DK();//from Yiyi
   static final number NUMERIC_DC = number.DC();//from Yiyi



}
